#include "m_service.h"



 uint32_t battery_char_add(my_serv * my_serv_struct)
{
	
    ble_gatts_char_md_t char_md;
    ble_gatts_attr_md_t cccd_md;
    ble_gatts_attr_t    attr_char_value;
    ble_uuid_t          ble_uuid;
    ble_gatts_attr_md_t attr_md;

    memset(&cccd_md, 0, sizeof(cccd_md));

    BLE_GAP_CONN_SEC_MODE_SET_OPEN(&cccd_md.read_perm);
    BLE_GAP_CONN_SEC_MODE_SET_OPEN(&cccd_md.write_perm);
    cccd_md.vloc = BLE_GATTS_VLOC_STACK;
    
    memset(&char_md, 0, sizeof(char_md));
    
    char_md.char_props.read   = 1;
    char_md.char_props.notify = 1;
    char_md.p_char_user_desc  = NULL;
    char_md.p_char_pf         = NULL;
    char_md.p_user_desc_md    = NULL;
    char_md.p_cccd_md         = &cccd_md;
    char_md.p_sccd_md         = NULL;
    
    ble_uuid.type = my_serv_struct->uuid_type;
    ble_uuid.uuid = UUID_BATTERY_CHAR;
    
    memset(&attr_md, 0, sizeof(attr_md));

    BLE_GAP_CONN_SEC_MODE_SET_OPEN(&attr_md.read_perm);
    BLE_GAP_CONN_SEC_MODE_SET_NO_ACCESS(&attr_md.write_perm);
    attr_md.vloc       = BLE_GATTS_VLOC_STACK;
    attr_md.rd_auth    = 0;
    attr_md.wr_auth    = 0;
    attr_md.vlen       = 0;
    
    memset(&attr_char_value, 0, sizeof(attr_char_value));

    attr_char_value.p_uuid       = &ble_uuid;
    attr_char_value.p_attr_md    = &attr_md;
    attr_char_value.init_len     = sizeof(uint8_t);
    attr_char_value.init_offs    = 0;
    attr_char_value.max_len      = sizeof(uint8_t);
    attr_char_value.p_value      = NULL;
    
    return sd_ble_gatts_characteristic_add(my_serv_struct->service_handle, &char_md,
                                               &attr_char_value,
                                               &my_serv_struct->battery_char_handles);
}
uint32_t ble_serv_init(my_serv * my_serv_struct)
{
    uint32_t   err_code;
    ble_uuid_t ble_uuid;

    ble_uuid128_t base_uuid = {MY_UUID_BASE};
    err_code = sd_ble_uuid_vs_add(&base_uuid, &my_serv_struct->uuid_type);
    if (err_code != NRF_SUCCESS)
    {
        return err_code;
    }
    ble_uuid.type = my_serv_struct->uuid_type;
    ble_uuid.uuid = MY_UUID_SERVICE;

    err_code = sd_ble_gatts_service_add(BLE_GATTS_SRVC_TYPE_PRIMARY, &ble_uuid, &my_serv_struct->service_handle);
		 if (err_code != NRF_SUCCESS)
    {
        return err_code;
    } 
    err_code = battery_char_add(my_serv_struct);
    if (err_code != NRF_SUCCESS)
    {
        return err_code;
    }
    
    
    return NRF_SUCCESS;
}
	

	
	
	